//+------------------------------------------------------------------+
//|                                         EMA-Crossover_Signal.mq4 |
//|         Copyright  2005, Jason Robinson (jnrtrading)            |
//|                   http://www.jnrtading.co.uk                     |
//+------------------------------------------------------------------+

#property copyright "Copyright  2005, Jason Robinson (jnrtrading)"
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

extern bool SoundON=true;
extern bool EmailON=false;

extern int MA_Period = 2;
extern int MA_Method = MODE_SMMA;
extern int PriceMode = PRICE_WEIGHTED;
extern int TimeShift = 0; //[IBFX = 0][FXDD = 3]

double CrossUp[];
double CrossDown[];
double alertTag;
double control=2147483647;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY,3);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY,3);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double MAnow, Pivotnow, MAprevious, Pivotprevious, MAafter, Pivotafter;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      MAnow = iMA(NULL, 0, MA_Period, 0, MA_Method, PriceMode, i);
      MAprevious = iMA(NULL, 0, MA_Period, 0, MA_Method, PriceMode, i+1);
      MAafter = iMA(NULL, 0, MA_Period, 0, MA_Method, PriceMode, i-1);

      Pivotnow = iCustom(NULL, 0, "TheOnlyPivot_Level_Sun", TimeShift, 0, i);
      Pivotprevious = iCustom(NULL, 0, "TheOnlyPivot_Level_Sun", TimeShift, 0, i+1);
      Pivotafter = iCustom(NULL,0,"TheOnlyPivot_Level_Sun", TimeShift, 0, i-1);
      
      if ((MAnow > Pivotnow) && (MAprevious < Pivotprevious) && (MAafter > Pivotafter)) {
         CrossUp[i] = Low[i] - Range*0.50;
      }
      else if ((MAnow < Pivotnow) && (MAprevious > Pivotprevious) && (MAafter < Pivotafter)) {
          CrossDown[i] = High[i] + Range*0.50;
      }
      
      if (i==1 && CrossUp[i] < CrossDown[i] && alertTag!=Time[0])//Buy Signal
         {
            if (SoundON)
               {
                Alert("BUY Signal at Ask: ",Ask,"\n Symbol: ",Symbol()," Period: ",Period(),"\n Date: ",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime()));
               }
        
            if (EmailON)
               {
               SendMail("Only Pivot: BUY Signal Alert","BUY Signal at Ask: "+DoubleToStr(Ask,4)+", Date: "+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol: "+Symbol()+" Period: "+Period());
               }
            alertTag = Time[0];
         }
                
     if (i==1 && CrossUp[i] > CrossDown[i] && alertTag!=Time[0])//Sell Signal
         {     
            if (SoundON) 
               {
                Alert("SELL Signal at Bid: ",Bid,"\n Symbol: ",Symbol()," Period: ",Period(),"\n Date: ",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime()));
               }
     
            if (EmailON) 
               {
                SendMail("Only Pivot: SELL Signal Alert","SELL Signal at Bid: "+DoubleToStr(Bid,4)+", Date: "+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol: "+Symbol()+" Period: "+Period());
               }
            alertTag = Time[0];
         }
        
  }
   return(0);
}

