//+------------------------------------------------------------------+
//|                                           WEEKLY_Pivot_Range.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property link      " Code modified by cja" 

#property indicator_chart_window

#property indicator_buffers 3
#property indicator_color1  Yellow
#property indicator_width1 0
#property indicator_color2  Red
#property indicator_width2 0
#property indicator_color3  Red
#property indicator_width3 0

extern bool LineTEXT =false;

//---- input parameters

//---- buffers
double PBuffer[];
double UP1Buffer[];
double DN1Buffer[];

string Pivot = "Pivot Point", Range_DN = "Range_DN", Range_UP = "Range_UP";

double P, UP, DN;
double LastHigh, LastLow, x,RANGE;


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{

   ObjectDelete("Pivot");
	ObjectDelete("Range_DN");
	ObjectDelete("Range_UP");

	//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{  string short_name,short_name2,short_name3;
	//---- indicator line
	SetIndexStyle(0, DRAW_LINE);
	SetIndexStyle(1, DRAW_LINE,STYLE_DASH);
	SetIndexStyle(2, DRAW_LINE,STYLE_DASH);
	
	SetIndexBuffer(0, PBuffer);
	SetIndexBuffer(1, DN1Buffer);
	SetIndexBuffer(2, UP1Buffer);
	
// Indicator name
	 short_name="WeeklyPivotPoint";
	 short_name2="WeeklyDownRange";
	 short_name3="WeeklyUpRange";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,short_name2);
   SetIndexLabel(2,short_name3);
	
	//----
	SetIndexDrawBegin(0,1);
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	if (LineTEXT == true)
	{
	ObjectCreate("Pivot", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Pivot", "                                         PIVOT", 7, "Arial",Silver);
	ObjectCreate("Range_DN", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Range_DN", "                                     RANGE DOWN", 7, "Arial", Silver);
	ObjectCreate("Range_UP", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Range_UP", "                                     RANGE UP", 7, "Arial", Silver);
   }
	//----
	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	int counted_bars = IndicatorCounted();
	int limit, i;


	if(counted_bars == 0)
	{
		x = Period();
		if(x > 240) 
			return(-1);

	}
	if(counted_bars < 0) 
		return(-1);
	
	limit = (Bars - counted_bars) - 1;
	//----
	for(i = limit; i >= 0; i--)
	{ 
		if(High[i+1] > LastHigh) 
			LastHigh = High[i+1];
		//----
		if(Low[i+1] < LastLow) 
			LastLow=Low[i+1];
			if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
		{
		   PBuffer[i+1] = EMPTY_VALUE;
		   DN1Buffer[i+1] = EMPTY_VALUE;
		   UP1Buffer[i+1] = EMPTY_VALUE;
		   
			RANGE = (LastHigh - LastLow)/2;
			P = (LastHigh + LastLow + Close[i+1]) / 3; 
			UP = (P + RANGE); 
			DN = (P - RANGE); 
		
			
		
			LastLow = Open[i]; 
			LastHigh = Open[i];
			
         ObjectMove("Pivot", 0, Time[i-0], P);
         ObjectMove("Range_DN", 0, Time[i-0], DN);
         ObjectMove("Range_UP", 0, Time[i-0], UP);
        
		}
		PBuffer[i] = P;
		DN1Buffer[i] = DN;
		UP1Buffer[i] = UP;
	
	}

	//----
	return(0);

}
//+------------------------------------------------------------------+

